/*
   Name:            Atheon_Server_v1.1
   Author:          zepplin <ross12002@hotmail.com>
   Description:     client/server program
   Date Begun:      Friday, Mar. 7, 2003
   Last Updated:    Wednesday, Jan. 28, 2004
   Version:         1.1
*/

#include <windows.h>
#include <fstream.h>
#include <string.h>
#include <winsock.h>
#include <stdio.h>
#include <time.h>

typedef int socklen_t;

#include <iostream>
#include <stdlib.h>
#include "server_help.h"

int login_server();
void logout_server();
int server_running();

struct sockaddr_in r_addr;
SOCKET    t1, new_fd;
socklen_t len = sizeof(r_addr);
int sin_size;

struct sockaddr_in addr;
SOCKET   s1;
int r;

int connected=1;

int main() {
	WSADATA wsa_data;
	WSAStartup(MAKEWORD(1,1), &wsa_data);
	do{
    login_server();
    server_running();
    logout_server();
   	}while(connected==1);
   	WSACleanup();
   	return 0;
}

int login_server() {
    int port=12002;

    s1 = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(INVALID_SOCKET == s1) {
        perror("Could not create socket");
        return 0;
    }

    memset((void*)&addr, 0, sizeof(addr));
    addr.sin_family      = AF_INET;
    addr.sin_addr.s_addr = htonl(INADDR_ANY);
    addr.sin_port        = htons(port);

    r = bind(s1, (struct sockaddr*)&addr, sizeof(addr));
    if(SOCKET_ERROR == r) {
        perror("Could not bind to local socket");
        closesocket(s1);
        return 0;
    }

    r = listen(s1, 10);
    if(SOCKET_ERROR == r) {
        perror("Could not listen to local socket");
        closesocket(s1);
        return 0;
    }
    connected=1;
}

int server_running()
{
        char user_input[1000];
        int session=1;
        int numbersent=0;
        do {
        numbersent++;

    	sin_size = sizeof(struct sockaddr_in);
    	char data[] = "Atheon_Server_v1.0\0";
        char log_o[] = "-!-logging out-!-\0";
    	char recieved[1024];

    	printf("Waiting for connection... ");

    	t1 = accept(s1, (struct sockaddr*)&r_addr, &len);
    	if(INVALID_SOCKET == s1) {
        	perror("Could not accept new connection");
            closesocket(s1);
            return 0;
         }

         printf("accepted.\n");

         printf("server: got connection from %s\n", inet_ntoa(r_addr.sin_addr));

         memset((void*)recieved, 0, sizeof(recieved));
         recv(t1, recieved, sizeof(recieved), 0);

         if(strcmp(recieved, "-!-logging out-!-") == 0) {
         cout<<"Client has disconnected or crashed."<<endl;
         session=0;
         return 0;
         }

         printf("Client: %s\n", recieved);

         switch(numbersent) {
         case 1: send(t1, data, strlen(data), 0);
                 break;
         default: cout<<"Send to client: ";
                  cin.get(user_input, 1000);
                  cin.ignore(80, '\n');
                  if(strcmp(user_input, "logout") == 0) {
                  send(t1, log_o, strlen(log_o), 0);
                  session=0;
                  connected=0;
                  return 0;
                  }
                  else if(strcmp(user_input, "about") == 0) {
                  send(t1, data, strlen(data), 0);
                  }
                  else {
                  send(t1, user_input, strlen(user_input), 0);
                  }
                  break;
         }

         ofstream save;
         save.open("ServerLog.txt", ios::app);
         if(save){
         	time_t tm;
         	time(&tm);
         	save<<asctime(localtime(&tm));
         	save<<"Sent > "<<data<<endl;
         	save<<"Recieved > "<<recieved<<endl;
         	save<<"Client IP Address > "<<inet_ntoa(r_addr.sin_addr)<<endl<<endl;
         	save.close();
         }
    }while(session==1);
    return 0;
}

void logout_server() {
             closesocket(t1);
             closesocket(s1);
             closesocket(new_fd);
}
